/*
 * Programmieren fuer Physiker, SS 2023, Blatt 11, Aufgabe 28
 *
 * Nullstellen mit (1) Bisektion und (2) Sekantenverf. (regula falsi)
 */

#include <iostream>
#include <cmath>
using namespace std ;

double f(double x)
{
    // return cos(x)-x ;
    return exp(x)-pow(x,3) ;
} 

double bisektion(double (*f)(double), double x0, double x1, double epsx, double epsf) 
{
    if( f(x0)*f(x1)>0)
    {
	cout << "Bisektion: Keine (od. mehrere) Nullstelle(n) im Intervall! " 
	     << endl ;
	return 0 ;
    }
    int steps = 0 ;
    double xneu, fneu ;
    do 
    {
	xneu = (x0+x1)/2.0 ;
	fneu = f(xneu) ;
	steps++ ;
	cout << "Schritt: " << steps 
	     << "  Intervall: " << x0 << " " << x1 
	     << "  xneu: " << xneu << "  fneu: " << fneu << endl ;
	if (fneu*f(x0)<0) x1=xneu ;
	else x0 = xneu ;
    }
    while (abs(x1-x0)>=epsx && abs(fneu)>=epsf) ;
    return xneu ;
}

double sekante(double (*f)(double), double x0, double x1, double epsx, double epsf) 
{
    double f0=f(x0), f1=f(x1) ;
    if( f0*f1>0)
    {
	cout << "Sekantenv.: Keine (od. mehrere) Nullstelle(n) im Intervall! " 
	     << endl ;
	return 0 ;
    }
    int steps = 0 ;
    double xneu, fneu ;
    do
    {
	xneu = (f1*x0-f0*x1)/(f1-f0) ;
	fneu = f(xneu) ;
	steps++ ;
	cout << "Schritt: " << steps 
	     << "  Intervall: " << x0 << " " << x1 
	     << "  xneu: " << xneu << "  fneu: " << fneu << endl ;
	if (fneu*f0<=0) 
	{ x1=xneu ; f1=fneu ; }
	else 
	{ x0=xneu ; f0=fneu ; }
    }
    while (abs(x1-x0)>=epsx && abs(fneu)>=epsf) ;
    return xneu ;
}
				
int main()
{
    double epsx=1e-4 ;
    double epsf=1e-3 ;
    double x0=2;
    double x1=10;
    
    cout << "Resultat Bisektion: " << bisektion(f, x0,x1,epsx,epsf) << endl ;
    // cout << "Resultat Sekantenv.: " << sekante(f,x0,x1,epsx,epsf) << endl ;
}
